import java.util.Vector;
import java.util.Iterator;
import java.util.Calendar;

public abstract class Contato {
   private String nome;
   private String tipo;
   private Vector email;
   private Telefone telefone;
   private byte[] foto;
   private String msn;
   private int icq; //----Duvida
   private Data aniversario;
   private Endereco endereco;

   public Contato() {
      this.nome = "";
      this.tipo = "Amigos";
      this.email = new Vector();
      this.telefone = new Telefone();
      this.foto = new byte[32767];
      this.msn = "";
      this.icq = 0;
      this.aniversario = null /*Data*/; // Verificar
      this.endereco = new Endereco();
   }

   private Contato(String n) {
      this.nome = n;
      this.tipo = "Amigos";
      this.email = new Vector();
      this.telefone = new Telefone();
      this.foto = new byte[32767];
      this.msn = "";
      this.icq = 0;
      this.aniversario = null /*Data*/; // Verificar
      this.endereco = new Endereco();
   }

   public void setNome(String novoNome) {
      this.nome = novoNome;
   }

   public boolean setTipo(String t) {
      boolean retorno = false;
      if (t.equals("Familia") || t.equals("Amigos") || t.equals("Profissional")) {
         this.tipo = t;
         retorno = true;
      }
      else {
         this.tipo = "Amigos";
         retorno = false;
      }
      return retorno;
   }

   public void setEmail(Vector e) {
      this.email = e;
   }

   public void setTelefone(Telefone t) {
      this.telefone = t;
   }

   public void setFoto(byte[] b) {
      this.foto = b;
   }

   public void setMsn(String msn) {
      if (this.emailValido(msn) || msn.equals("")) {
         this.msn = msn;
      }
   }

   public void setIcq(int i) {
      this.icq = i;
   }

   public void setAniversario(Data c) {
      this.aniversario = c;
   }

   public void setEndereco(Endereco end) {
      this.endereco = end;
   }

   public String getNome() {
      return this.nome;
   }

   public String getTipo() {
      return this.tipo;
   }

   public Vector getEmail() {
      return this.email;
   }

   public Telefone getTelefone() {
      return this.telefone;
   }

   public byte[] getFoto() {
      return this.foto;
   }

   public String getMsn() {
      return this.msn;
   }

   public int getIcq() {
      return this.icq;
   }

   public Data getAniversario() {
      return this.aniversario;
   }

   public Endereco getEndereco() {
      return this.endereco;
   }

   public boolean emailValido(String e) {
      boolean retorno = false;
      int i = 0;
      while (i < e.length() && !retorno) {
         if (e.charAt(i) == '@') {
            retorno = true;
         }
      }
      return retorno;
   }

   public void insereEmail(String email) {
      if (this.emailValido(email)) {
         this.email.add(email);
      }
   }

   public boolean msnValido(String s) {
      boolean retorno = false;
      if (this.emailValido(s)) {
         int i = 0;
         while (!retorno && (i + 7) < s.length()) {
            if (s.substring(i).equals("msn.com")) {
               retorno = true;
            }
            else {
               i = i + 1;
            }
         }
         i = 0;
         while (!retorno && (i + 11) < s.length()) {
            if (s.substring(i).equals("hotmail.com")) {
               retorno = true;
            }
            else {
               i = i + 1;
            }
         }
      }
      return retorno;
   }

   public String getDataString() {
      return this.getAniversario().toString();
   }

   public String toString() {
      String ret = "'" + this.nome + "','" + this.tipo + "',Email(";
      Iterator it = this.getEmail().iterator();
      String temp = (String)this.email.get(0);
      while (it.hasNext()) {
         temp = "'" + temp + "'";
         temp = (String) it.next();
         if (temp != null && temp != "") {
            ret = ret + ",";
         }
      }
      ret = ret + ")," + this.telefone.toString() + "," + this.foto + ",'";
      ret = ret + this.getMsn() + "'," + this.getIcq() + ",to_date('" +
        this.getDataString() + "','dd/mm/yyyy'),";
      ret = ret + "Endereco(" + this.getEndereco().toString() + ")";
      return ret;
   }

}